/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

package org.ow2.jonas.webapp.jonasadmin.joramplatform;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Vector;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ow2.jonas.lib.util.JonasObjectName;
import org.ow2.jonas.webapp.jonasadmin.JonasManagementRepr;
import org.ow2.jonas.webapp.jonasadmin.WhereAreYou;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


/**
 * @author Adriana Danes
 */

public class ListRemoteDestinationsAction extends EditJoramBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping pMapping, ActionForm pForm
        , HttpServletRequest pRequest, HttpServletResponse pResponse)
        throws IOException, ServletException {

        // Current JOnAS server
        String jonasServerName =  m_WhereAreYou.getCurrentJonasServerName();

        String id = pRequest.getParameter("id");
        if (id == null) {
            // Try to get from the session
            id = (String) m_Session.getAttribute("remoteServerId");
        }

        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_DOMAIN) + WhereAreYou.NODE_SEPARATOR
                + "joramplatform" + WhereAreYou.NODE_SEPARATOR
                + "joramremoteserver" + id, true);

        try {
            // Object name used for JmslocalServer MBean
            ObjectName oObjectName = JonasObjectName.joramRemoteServer(id);
            String asDestName = null;
            ArrayList alQueues = new ArrayList();
            // get queues
            Vector v = (Vector) JonasManagementRepr.invoke(oObjectName, "retrieveRemoteQueuesNames", null, null, jonasServerName);
            if (v != null) {
                for (int i = 0; i < v.size(); i++) {
                    asDestName = (String) v.get(i);
                    boolean deps = false;
                    // Chech dependences
                    // TO DO
                    alQueues.add(new DestinationItem(asDestName, "queue", deps));
                }
            }
            // get topicss
            v = (Vector) JonasManagementRepr.invoke(oObjectName, "retrieveRemoteTopicsNames", null, null, jonasServerName);
            ArrayList alTopics = new ArrayList();
            if (v != null) {
                for (int i = 0; i < v.size(); i++) {
                    asDestName = (String) v.get(i);
                    boolean deps = false;
                    // Chech dependences
                    // TO DO
                    alTopics.add(new DestinationItem(asDestName, "topic", deps));
                }
            }

            // merge alQueues and alTopics in alDestinations
            ArrayList alDestinations = new ArrayList(alQueues);
            alDestinations.addAll(alTopics);

            pRequest.setAttribute("destinationsList", alDestinations);
        } catch (Throwable t) {
            return (treatError(t, pMapping, pRequest));
        }

        // Forward to the jsp.
        return (pMapping.findForward("Joram Remote Destinations"));
    }

}
